Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 1975)
+++ palm/trunk/SOURCE/Makefile	(revision 1976)
@@ -509,5 +509,5 @@
 mod_particle_attributes.o: mod_particle_attributes.f90 mod_kinds.o
 netcdf_interface_mod.o: netcdf_interface_mod.f90 modules.o mod_kinds.o \
-   land_surface_model_mod.o spectra_mod.o
+   land_surface_model_mod.o radiation_model_mod.o spectra_mod.o
 nudging_mod.o: modules.o cpulog_mod.o mod_kinds.o
 package_parin.o: modules.o mod_kinds.o mod_particle_attributes.o
Index: palm/trunk/SOURCE/average_3d_data.f90
===================================================================
--- palm/trunk/SOURCE/average_3d_data.f90	(revision 1975)
+++ palm/trunk/SOURCE/average_3d_data.f90	(revision 1976)
@@ -101,9 +101,5 @@
 
     USE radiation_model_mod,                                                   &
-        ONLY:  rad_net, rad_net_av, rad_lw_in, rad_lw_in_av, rad_lw_out,       &
-               rad_lw_out_av, rad_lw_cs_hr, rad_lw_cs_hr_av, rad_lw_hr,        &
-               rad_lw_hr_av, rad_sw_in, rad_sw_in_av, rad_sw_out,              &
-               rad_sw_out_av, rad_sw_cs_hr, rad_sw_cs_hr_av, rad_sw_hr,        &
-               rad_sw_hr_av
+        ONLY:  radiation, radiation_3d_data_averaging
 
 
@@ -295,83 +291,4 @@
              ENDDO
 
-         CASE ( 'rad_net*' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   rad_net_av(j,i) = rad_net_av(j,i) / REAL( average_count_3d, KIND=wp )
-                ENDDO
-             ENDDO
-
-          CASE ( 'rad_lw_in' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      rad_lw_in_av(k,j,i) = rad_lw_in_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
-
-          CASE ( 'rad_lw_out' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      rad_lw_out_av(k,j,i) = rad_lw_out_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
-
-          CASE ( 'rad_lw_cs_hr' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      rad_lw_cs_hr_av(k,j,i) = rad_lw_cs_hr_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
-
-          CASE ( 'rad_lw_hr' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      rad_lw_hr_av(k,j,i) = rad_lw_hr_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
-
-          CASE ( 'rad_sw_in' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      rad_sw_in_av(k,j,i) = rad_sw_in_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
-
-          CASE ( 'rad_sw_out' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      rad_sw_out_av(k,j,i) = rad_sw_out_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
-
-          CASE ( 'rad_sw_cs_hr' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      rad_sw_cs_hr_av(k,j,i) = rad_sw_cs_hr_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
-
-          CASE ( 'rad_sw_hr' )
-             DO  i = nxlg, nxrg
-                DO  j = nysg, nyng
-                   DO  k = nzb, nzt+1
-                      rad_sw_hr_av(k,j,i) = rad_sw_hr_av(k,j,i) / REAL( average_count_3d, KIND=wp )
-                   ENDDO
-                ENDDO
-             ENDDO
-
           CASE ( 'rho' )
              DO  i = nxlg, nxrg
@@ -487,4 +404,10 @@
 
 !
+!--          Radiation quantity
+             IF ( radiation )  THEN
+                CALL radiation_3d_data_averaging( 'average', doav(ii) )
+             ENDIF
+
+!
 !--          User-defined quantity
              CALL user_3d_data_averaging( 'average', doav(ii) )
Index: palm/trunk/SOURCE/data_output_2d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_2d.f90	(revision 1975)
+++ palm/trunk/SOURCE/data_output_2d.f90	(revision 1976)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Output of radiation quantities is now done directly in the respective module
 ! 
 ! Former revisions:
@@ -26,5 +26,6 @@
 !
 ! 1972 2016-07-26 07:52:02Z maronga
-! Output of land surface quantities is now done directly in the respective module
+! Output of land surface quantities is now done directly in the respective 
+! module
 ! 
 ! 1960 2016-07-12 16:34:24Z suehring
@@ -195,9 +196,5 @@
 
     USE radiation_model_mod,                                                   &
-        ONLY:  rad_net, rad_net_av, rad_sw_in, rad_sw_in_av, rad_sw_out,       &
-               rad_sw_out_av, rad_sw_cs_hr, rad_sw_cs_hr_av, rad_sw_hr,        &
-               rad_sw_hr_av, rad_lw_in, rad_lw_in_av, rad_lw_out,              &
-               rad_lw_out_av, rad_lw_cs_hr, rad_lw_cs_hr_av, rad_lw_hr,        &
-               rad_lw_hr_av
+        ONLY:  radiation, radiation_data_output_2d
 
     IMPLICIT NONE
@@ -753,86 +750,5 @@
                 IF ( mode == 'xy' )  level_z = zu
 
-             CASE ( 'rad_net*_xy' )        ! 2d-array
-                IF ( av == 0 ) THEN
-                   DO  i = nxlg, nxrg
-                      DO  j = nysg, nyng
-                         local_pf(i,j,nzb+1) =  rad_net(j,i)
-                      ENDDO
-                   ENDDO
-                ELSE
-                   DO  i = nxlg, nxrg
-                      DO  j = nysg, nyng 
-                         local_pf(i,j,nzb+1) =  rad_net_av(j,i)
-                      ENDDO
-                   ENDDO
-                ENDIF
-                resorted = .TRUE.
-                two_d = .TRUE.
-                level_z(nzb+1) = zu(nzb+1)
-
-
-             CASE ( 'rad_lw_in_xy', 'rad_lw_in_xz', 'rad_lw_in_yz' )
-                IF ( av == 0 )  THEN
-                   to_be_resorted => rad_lw_in
-                ELSE
-                   to_be_resorted => rad_lw_in_av
-                ENDIF
-                IF ( mode == 'xy' )  level_z = zu
-
-             CASE ( 'rad_lw_out_xy', 'rad_lw_out_xz', 'rad_lw_out_yz' )
-                IF ( av == 0 )  THEN
-                   to_be_resorted => rad_lw_out
-                ELSE
-                   to_be_resorted => rad_lw_out_av
-                ENDIF
-                IF ( mode == 'xy' )  level_z = zu
-
-             CASE ( 'rad_lw_cs_hr_xy', 'rad_lw_cs_hr_xz', 'rad_lw_cs_hr_yz' )
-                IF ( av == 0 )  THEN
-                   to_be_resorted => rad_lw_cs_hr
-                ELSE
-                   to_be_resorted => rad_lw_cs_hr_av
-                ENDIF
-                IF ( mode == 'xy' )  level_z = zw
-
-             CASE ( 'rad_lw_hr_xy', 'rad_lw_hr_xz', 'rad_lw_hr_yz' )
-                IF ( av == 0 )  THEN
-                   to_be_resorted => rad_lw_hr
-                ELSE
-                   to_be_resorted => rad_lw_hr_av
-                ENDIF
-                IF ( mode == 'xy' )  level_z = zw
-
-             CASE ( 'rad_sw_in_xy', 'rad_sw_in_xz', 'rad_sw_in_yz' )
-                IF ( av == 0 )  THEN
-                   to_be_resorted => rad_sw_in
-                ELSE
-                   to_be_resorted => rad_sw_in_av
-                ENDIF
-                IF ( mode == 'xy' )  level_z = zu
-
-             CASE ( 'rad_sw_out_xy', 'rad_sw_out_xz', 'rad_sw_out_yz' )
-                IF ( av == 0 )  THEN
-                   to_be_resorted => rad_sw_out
-                ELSE
-                   to_be_resorted => rad_sw_out_av
-                ENDIF
-                IF ( mode == 'xy' )  level_z = zu
-
-             CASE ( 'rad_sw_cs_hr_xy', 'rad_sw_cs_hr_xz', 'rad_sw_cs_hr_yz' )
-                IF ( av == 0 )  THEN
-                   to_be_resorted => rad_sw_cs_hr
-                ELSE
-                   to_be_resorted => rad_sw_cs_hr_av
-                ENDIF
-                IF ( mode == 'xy' )  level_z = zw
-
-             CASE ( 'rad_sw_hr_xy', 'rad_sw_hr_xz', 'rad_sw_hr_yz' )
-                IF ( av == 0 )  THEN
-                   to_be_resorted => rad_sw_hr
-                ELSE
-                   to_be_resorted => rad_sw_hr_av
-                ENDIF
-                IF ( mode == 'xy' )  level_z = zw
+
 
              CASE ( 'rho_xy', 'rho_xz', 'rho_yz' )
@@ -1034,4 +950,11 @@
                    CALL lsm_data_output_2d( av, do2d(av,if), found, grid, mode,&
                                             local_pf, two_d, nzb_do, nzt_do )
+                ENDIF
+
+!
+!--             Radiation quantity
+                IF ( .NOT. found  .AND.  radiation )  THEN
+                   CALL radiation_data_output_2d( av, do2d(av,if), found, grid,&
+                                                  mode, local_pf, two_d  )
                 ENDIF
 
Index: palm/trunk/SOURCE/data_output_3d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_3d.f90	(revision 1975)
+++ palm/trunk/SOURCE/data_output_3d.f90	(revision 1976)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Output of radiation quantities is now done directly in the respective module
 ! 
 ! Former revisions:
@@ -165,8 +165,5 @@
 
     USE radiation_model_mod,                                                   &
-        ONLY:  rad_lw_in, rad_lw_in_av, rad_lw_out, rad_lw_out_av,             &
-               rad_lw_cs_hr, rad_lw_cs_hr_av, rad_lw_hr, rad_lw_hr_av,         &
-               rad_sw_in, rad_sw_in_av, rad_sw_out, rad_sw_out_av,             &
-               rad_sw_cs_hr, rad_sw_cs_hr_av, rad_sw_hr, rad_sw_hr_av
+        ONLY:  radiation, radiation_data_output_3d
 
 
@@ -494,60 +491,4 @@
              ENDIF
 
-          CASE ( 'rad_sw_in' )
-             IF ( av == 0 )  THEN
-                to_be_resorted => rad_sw_in
-             ELSE
-                to_be_resorted => rad_sw_in_av
-             ENDIF
-
-          CASE ( 'rad_sw_out' )
-             IF ( av == 0 )  THEN
-                to_be_resorted => rad_sw_out
-             ELSE
-                to_be_resorted => rad_sw_out_av
-             ENDIF
-
-          CASE ( 'rad_sw_cs_hr' )
-             IF ( av == 0 )  THEN
-                to_be_resorted => rad_sw_cs_hr
-             ELSE
-                to_be_resorted => rad_sw_cs_hr_av
-             ENDIF
-
-          CASE ( 'rad_sw_hr' )
-             IF ( av == 0 )  THEN
-                to_be_resorted => rad_sw_hr
-             ELSE
-                to_be_resorted => rad_sw_hr_av
-             ENDIF
-
-          CASE ( 'rad_lw_in' )
-             IF ( av == 0 )  THEN
-                to_be_resorted => rad_lw_in
-             ELSE
-                to_be_resorted => rad_lw_in_av
-             ENDIF
-
-          CASE ( 'rad_lw_out' )
-             IF ( av == 0 )  THEN
-                to_be_resorted => rad_lw_out
-             ELSE
-                to_be_resorted => rad_lw_out_av
-             ENDIF
-
-          CASE ( 'rad_lw_cs_hr' )
-             IF ( av == 0 )  THEN
-                to_be_resorted => rad_lw_cs_hr
-             ELSE
-                to_be_resorted => rad_lw_cs_hr_av
-             ENDIF
-
-          CASE ( 'rad_lw_hr' )
-             IF ( av == 0 )  THEN
-                to_be_resorted => rad_lw_hr
-             ELSE
-                to_be_resorted => rad_lw_hr_av
-             ENDIF
-
           CASE ( 'rho' )
              IF ( av == 0 )  THEN
@@ -613,4 +554,23 @@
 
                 CALL lsm_data_output_3d( av, do3d(av,if), found, local_pf )
+                resorted = .TRUE.
+
+!
+!--             If no soil model variable was found, re-allocate local_pf
+                IF ( .NOT. found )  THEN
+                   nzb_do = nzb
+                   nzt_do = nz_do3d
+
+                   DEALLOCATE ( local_pf )
+                   ALLOCATE( local_pf(nxlg:nxrg,nysg:nyng,nzb_do:nzt_do) )                 
+                ENDIF
+
+             ENDIF
+
+!
+!--          Radiation quantity
+             IF ( .NOT. found  .AND.  radiation )  THEN
+                CALL radiation_data_output_3d( av, do3d(av,if), found,         &
+                                               local_pf )
                 resorted = .TRUE.
              ENDIF
Index: palm/trunk/SOURCE/data_output_mask.f90
===================================================================
--- palm/trunk/SOURCE/data_output_mask.f90	(revision 1975)
+++ palm/trunk/SOURCE/data_output_mask.f90	(revision 1976)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Output of radiation quantities is now done directly in the respective module
 ! 
 ! Former revisions:
@@ -127,9 +127,5 @@
 
     USE radiation_model_mod,                                                   &
-        ONLY:  rad_lw_in, rad_lw_in_av, rad_lw_out, rad_lw_out_av,             &
-               rad_lw_cs_hr, rad_lw_cs_hr_av, rad_lw_hr, rad_lw_hr_av,         &
-               rad_sw_in, rad_sw_in_av, rad_sw_out, rad_sw_out_av,             &
-               rad_sw_cs_hr, rad_sw_cs_hr_av, rad_sw_hr, rad_sw_hr_av
-
+        ONLY:  radiation, radiation_data_output_mask
 
     IMPLICIT NONE
@@ -425,60 +421,4 @@
              ENDIF
 
-          CASE ( 'rad_lw_in' )
-             IF ( av == 0 )  THEN
-                to_be_resorted => rad_lw_in
-             ELSE
-                to_be_resorted => rad_lw_in_av
-             ENDIF
-
-          CASE ( 'rad_lw_out' )
-             IF ( av == 0 )  THEN
-                to_be_resorted => rad_lw_out
-             ELSE
-                to_be_resorted => rad_lw_out_av
-             ENDIF
-
-          CASE ( 'rad_lw_cs_hr' )
-             IF ( av == 0 )  THEN
-                to_be_resorted => rad_lw_cs_hr
-             ELSE
-                to_be_resorted => rad_lw_cs_hr_av
-             ENDIF
-
-          CASE ( 'rad_lw_hr' )
-             IF ( av == 0 )  THEN
-                to_be_resorted => rad_lw_hr
-             ELSE
-                to_be_resorted => rad_lw_hr_av
-             ENDIF
-
-          CASE ( 'rad_sw_in' )
-             IF ( av == 0 )  THEN
-                to_be_resorted => rad_sw_in
-             ELSE
-                to_be_resorted => rad_sw_in_av
-             ENDIF
-
-          CASE ( 'rad_sw_out' )
-             IF ( av == 0 )  THEN
-                to_be_resorted => rad_sw_out
-             ELSE
-                to_be_resorted => rad_sw_out_av
-             ENDIF
-
-          CASE ( 'rad_sw_cs_hr' )
-             IF ( av == 0 )  THEN
-                to_be_resorted => rad_sw_cs_hr
-             ELSE
-                to_be_resorted => rad_sw_cs_hr_av
-             ENDIF
-
-          CASE ( 'rad_sw_hr' )
-             IF ( av == 0 )  THEN
-                to_be_resorted => rad_sw_hr
-             ELSE
-                to_be_resorted => rad_sw_hr_av
-             ENDIF
-
           CASE ( 'rho' )
              IF ( av == 0 )  THEN
@@ -531,7 +471,19 @@
 
           CASE DEFAULT
+
+!
+!--          Radiation quantity
+             IF ( radiation )  THEN
+                CALL radiation_data_output_mask(av, domask(mid,av,if), found,  &
+                                                local_pf )
+             ENDIF
+
 !
 !--          User defined quantity
-             CALL user_data_output_mask(av, domask(mid,av,if), found, local_pf )
+             IF ( .NOT. found )  THEN
+                CALL user_data_output_mask(av, domask(mid,av,if), found,       &
+                                           local_pf )
+             ENDIF
+
              resorted = .TRUE.
 
Index: palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- palm/trunk/SOURCE/flow_statistics.f90	(revision 1975)
+++ palm/trunk/SOURCE/flow_statistics.f90	(revision 1976)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Removed some unneeded __rrtmg preprocessor directives
 ! 
 ! Former revisions:
@@ -832,7 +832,5 @@
                 ENDIF
 #endif
-
              ENDIF
-
 !
 !--          Subgridscale fluxes at the top surface
@@ -1447,5 +1445,4 @@
 
           IF ( radiation_scheme == 'rrtmg' )  THEN
-#if defined ( __rrtmg )
              hom(:,1,106,sr) = sums(:,106)            ! rad_lw_cs_hr
              hom(:,1,107,sr) = sums(:,107)            ! rad_lw_hr
@@ -1457,8 +1454,5 @@
              hom(:,1,112,sr) = sums(:,112)            ! rrtm_asdif
              hom(:,1,113,sr) = sums(:,113)            ! rrtm_asdir
-#endif
           ENDIF
-
-
        ENDIF
 
@@ -1643,5 +1637,4 @@
           ts_value(dots_rad+4,sr) = hom(nzb,1,105,sr)          ! rad_sw_out
 
-#if defined ( __rrtmg )
           IF ( radiation_scheme == 'rrtmg' )  THEN
              ts_value(dots_rad+5,sr) = hom(nzb,1,110,sr)          ! rrtm_aldif
@@ -1650,5 +1643,4 @@
              ts_value(dots_rad+8,sr) = hom(nzb,1,113,sr)          ! rrtm_asdir
           ENDIF
-#endif
 
        ENDIF
@@ -3619,5 +3611,4 @@
           ts_value(dots_rad+4,sr) = hom(nzb,1,105,sr)          ! rad_sw_out
 
-#if defined ( __rrtmg )
           IF ( radiation_scheme == 'rrtmg' )  THEN
              ts_value(dots_rad+5,sr) = hom(nzb,1,106,sr)          ! rrtm_aldif
@@ -3626,5 +3617,4 @@
              ts_value(dots_rad+8,sr) = hom(nzb,1,109,sr)          ! rrtm_asdir
           ENDIF
-#endif
 
        ENDIF
